// Copyright 2016-2017 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/blox/blox/daemon-scheduler/swagger/v1/generated/models"
)

// CreateDeploymentReader is a Reader for the CreateDeployment structure.
type CreateDeploymentReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateDeploymentReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewCreateDeploymentOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewCreateDeploymentBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewCreateDeploymentNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewCreateDeploymentOK creates a CreateDeploymentOK with default headers values
func NewCreateDeploymentOK() *CreateDeploymentOK {
	return &CreateDeploymentOK{}
}

/*CreateDeploymentOK handles this case with default header values.

OK
*/
type CreateDeploymentOK struct {
	Payload *models.Deployment
}

func (o *CreateDeploymentOK) Error() string {
	return fmt.Sprintf("[POST /environments/{name}/deployments][%d] createDeploymentOK  %+v", 200, o.Payload)
}

func (o *CreateDeploymentOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Deployment)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateDeploymentBadRequest creates a CreateDeploymentBadRequest with default headers values
func NewCreateDeploymentBadRequest() *CreateDeploymentBadRequest {
	return &CreateDeploymentBadRequest{}
}

/*CreateDeploymentBadRequest handles this case with default header values.

Bad Request
*/
type CreateDeploymentBadRequest struct {
	Payload string
}

func (o *CreateDeploymentBadRequest) Error() string {
	return fmt.Sprintf("[POST /environments/{name}/deployments][%d] createDeploymentBadRequest  %+v", 400, o.Payload)
}

func (o *CreateDeploymentBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateDeploymentNotFound creates a CreateDeploymentNotFound with default headers values
func NewCreateDeploymentNotFound() *CreateDeploymentNotFound {
	return &CreateDeploymentNotFound{}
}

/*CreateDeploymentNotFound handles this case with default header values.

Resource not found
*/
type CreateDeploymentNotFound struct {
	Payload string
}

func (o *CreateDeploymentNotFound) Error() string {
	return fmt.Sprintf("[POST /environments/{name}/deployments][%d] createDeploymentNotFound  %+v", 404, o.Payload)
}

func (o *CreateDeploymentNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
