// Copyright 2016-2017 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/validate"
)

// CreateEnvironmentRequest Request object to CreateEnvironment api
// swagger:model CreateEnvironmentRequest
type CreateEnvironmentRequest struct {

	// instance group
	// Required: true
	InstanceGroup *InstanceGroup `json:"instanceGroup"`

	// name
	// Required: true
	// Pattern: ^[a-zA-Z0-9-_]{1,30}$
	Name *string `json:"name"`

	// task definition
	// Required: true
	TaskDefinition *string `json:"taskDefinition"`
}

// Validate validates this create environment request
func (m *CreateEnvironmentRequest) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateInstanceGroup(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := m.validateTaskDefinition(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *CreateEnvironmentRequest) validateInstanceGroup(formats strfmt.Registry) error {

	if err := validate.Required("instanceGroup", "body", m.InstanceGroup); err != nil {
		return err
	}

	if m.InstanceGroup != nil {

		if err := m.InstanceGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("instanceGroup")
			}
			return err
		}
	}

	return nil
}

func (m *CreateEnvironmentRequest) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	if err := validate.Pattern("name", "body", string(*m.Name), `^[a-zA-Z0-9-_]{1,30}$`); err != nil {
		return err
	}

	return nil
}

func (m *CreateEnvironmentRequest) validateTaskDefinition(formats strfmt.Registry) error {

	if err := validate.Required("taskDefinition", "body", m.TaskDefinition); err != nil {
		return err
	}

	return nil
}
