// Copyright 2016-2017 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/validate"
)

// HealthStatus health status
// swagger:model HealthStatus
type HealthStatus string

const (
	// HealthStatusHealthy captures enum value "healthy"
	HealthStatusHealthy HealthStatus = "healthy"
	// HealthStatusUnhealthy captures enum value "unhealthy"
	HealthStatusUnhealthy HealthStatus = "unhealthy"
)

// for schema
var healthStatusEnum []interface{}

func init() {
	var res []HealthStatus
	if err := json.Unmarshal([]byte(`["healthy","unhealthy"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		healthStatusEnum = append(healthStatusEnum, v)
	}
}

func (m HealthStatus) validateHealthStatusEnum(path, location string, value HealthStatus) error {
	if err := validate.Enum(path, location, value, healthStatusEnum); err != nil {
		return err
	}
	return nil
}

// Validate validates this health status
func (m HealthStatus) Validate(formats strfmt.Registry) error {
	var res []error

	// value enum
	if err := m.validateHealthStatusEnum("", "body", m); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
